SystemOrganization addCategory: #'Uqbar-Tools-ScriptBuilder'!

Object subclass: #ScriptBuilder
	instanceVariableNames: 'output'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Uqbar-Tools-ScriptBuilder'!

!ScriptBuilder class methodsFor: 'as yet unclassified' stamp: 'npasserini 10/29/2011 20:02'!
PAOOMetaProgrammingExample
"self PAOOMetaProgrammingExample"

"Definition of package: PAOO-MetaProgramming-Example"
"Delete all current classes in package"
(PackageInfo named: 'PAOO-MetaProgramming-Example') classes do: [: class | class removeFromSystem ].

"Re-create package"
PackageInfo registerPackageName: 'PAOO-MetaProgramming-Example'.

"Definition of class: AgeOfEmpiresTest"
TestCase subclass: #AgeOfEmpiresTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PAOO-Metaprogramming-Example'.

(Smalltalk at: #AgeOfEmpiresTest) compile: 'testSaveGame
	| original saved fileName |
	
	"Crear un juego y bajarlo a disco"
	original := self crearMapaEjemplo.
	fileName := ''game1.dat''
	
	original saveAs: fileName.
	
	"Recuperar el juego del disco y ver que obtengo los mismos datos"
	saved := Mapa loadFrom: fileName.
	self assert: fileName = saved.
	' classified: #tests.

"Definition of class: Mapa"
Object subclass: #Mapa
	instanceVariableNames: 'personajes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PAOO-Metaprogramming-Example'.

(Smalltalk at: #Mapa) compile: 'save: aFileName
	self flag: #todo' classified: #'editing keys'.

(Smalltalk at: #Mapa) compile: 'personajes
	^ personajes' classified: #accessing.

(Smalltalk at: #Mapa) compile: 'personajes: anObject
	personajes := anObject' classified: #accessing.

(Smalltalk at: #Mapa) class  compile: 'loadFrom: aFileName
	self flag: #todo' classified: #'as yet unclassified'.

"Definition of class: Soldado"
Object subclass: #Soldado
	instanceVariableNames: 'posicion puntosDeVida'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PAOO-Metaprogramming-Example'.

(Smalltalk at: #Soldado) compile: 'posicion
	^ posicion.' classified: #accessing.

(Smalltalk at: #Soldado) compile: 'golpear: aSoldado 
	aSoldado recibirDao: self fuerza.' classified: #'as yet unclassified'.

(Smalltalk at: #Soldado) compile: 'initialize: aPoint 
	posicion := aPoint.
	puntosDeVida := 100.' classified: #initialization.

(Smalltalk at: #Soldado) compile: 'atacar: unOponente
	(self estaCercaDe: unOponente) 
		whileFalse: [ self avanzarHacia: unOponente posicion ].
		
	self golpear: unOponente.' classified: #'as yet unclassified'.

(Smalltalk at: #Soldado) compile: 'fuerza
	^ 10.' classified: #'as yet unclassified'.

(Smalltalk at: #Soldado) compile: 'estaCercaDe: unOponente
	(self posicion dist: unOponente posicion) < 5' classified: #'as yet unclassified'.

(Smalltalk at: #Soldado) compile: 'direccionHacia: unOponente
	(self posicion - unOponente posicion) normalized.' classified: #'as yet unclassified'.

(Smalltalk at: #Soldado) compile: 'paso
	^ (puntosDeVida / 10)' classified: #'as yet unclassified'.

(Smalltalk at: #Soldado) compile: 'avanzarHacia: unOponente
	posicion := posicion +  ((self direccionHacia: unOponente) * self paso)' classified: #'as yet unclassified'.

(Smalltalk at: #Soldado) compile: 'recibirDao: unaPotencia
	puntosDeVida := puntosDeVida - unaPotencia' classified: #'as yet unclassified'.

(Smalltalk at: #Soldado) class  compile: 'enPosicion: unaPosicion
	^ self new initialize: unaPosicion' classified: #'as yet unclassified'.

! !

!ScriptBuilder class methodsFor: 'as yet unclassified' stamp: 'npasserini 10/28/2011 23:47'!
PAOOMetaProgrammingRefactorings
"self PAOOMetaProgrammingRefactorings"

"Definition of package: PAOO-MetaProgramming-Refactorings"
"Delete all current classes in package"
(PackageInfo named: 'PAOO-MetaProgramming-Refactorings') classes do: [: class | class removeFromSystem ].

"Re-create package"
PackageInfo registerPackageName: 'PAOO-MetaProgramming-Refactorings'.

"Definition of class: SimpleExtractSuperclassRefactoring"
Object subclass: #SimpleExtractSuperclassRefactoring
	instanceVariableNames: 'target superClassName selectors instanceVariableNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PAOO-Metaprogramming-Refactorings'.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: 'createSuperclass.
	^ target superclass
		subclass:  self superClassName
		instanceVariableNames: self superclassInstanceVariablesDefinition
		classVariableNames:  ''''
		poolDictionaries:  ''''
		category: target category.
'.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: 'instanceVariableNames
	^ instanceVariableNames'.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: 'targetInstanceVariablesDefinition
	^ self instanceVariablesDefinitionFor: self targetInstanceVariables	
'.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: 'targetInstanceVariables	
	^ self target instVarNames difference: self instanceVariableNames 
'.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: 'instanceVariableNames: anObject
	instanceVariableNames := anObject'.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: 'moveMethodNamed: selector to: newClass
	| method |
	method := self target methodDictionary at: selector.
	self target removeSelector: selector.
	newClass compile: method getSource.
'.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: 'selectors: anObject
	selectors := anObject'.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: 'superClassName
	^ superClassName'.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: 'instanceVariablesDefinitionFor: aCollection
	^ (String streamContents: [:s | aCollection asStringOn: s delimiter: '' '' ])

'.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: 'execute
	| superclass |
	superclass := self createSuperclass.
	self selectors do: [:selector | self moveMethodNamed: selector to: superclass].
	self makeTargetSubclassOf: superclass.
'.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: 'selectors
	^ selectors'.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: 'superclassInstanceVariablesDefinition
	^ self instanceVariablesDefinitionFor: self instanceVariableNames.
'.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: 'makeTargetSubclassOf: superclass.
	superclass
		subclass:  self target name
		instanceVariableNames: self targetInstanceVariablesDefinition
		classVariableNames:  ''''
		poolDictionaries:  ''''
		category: target category.
'.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: 'target
	^ target'.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: 'superClassName: anObject
	superClassName := anObject'.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: 'target: anObject
	target := anObject'.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) class compile: 'extractSuperclass: newSuperClassName 
	withInstanceVariables: instanceVariableNames
	andMethods: selectors 
	fromClass: aClass 
	
	self new
		target: aClass;
		superClassName: newSuperClassName;
		instanceVariableNames: instanceVariableNames;
		selectors: selectors; 
		execute.
'.

"Definition of class: SimpleExtractTraitRefactoring"
Object subclass: #SimpleExtractTraitRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PAOO-Metaprogramming-Refactorings'.

(Smalltalk at: #SimpleExtractTraitRefactoring) class compile: 'extractTrait: traitName withMethods: selectors fromClass: aClass 
	| trait |
	trait := Trait named: traitName
		uses: {}
		category: aClass category.
		
	selectors do: [:selector | | method |
		method := aClass methodDictionary at: selector.
		aClass removeSelector: selector.
		trait compile: method getSource.
	].
	
	aClass addToComposition: trait.
'.

"Definition of class: SimpleExtractTraitTest"
TestCase subclass: #SimpleExtractTraitTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PAOO-Metaprogramming-Refactorings'.

(Smalltalk at: #SimpleExtractTraitTest) compile: 'category
	^ self class category'.

(Smalltalk at: #SimpleExtractTraitTest) compile: 'tearDown
	(Smalltalk at: #Perro) removeFromSystem.
	(Smalltalk at: #Animal) removeFromSystem. 
	(Smalltalk at: #TCuadrupedo) removeFromSystem. 
'.

(Smalltalk at: #SimpleExtractTraitTest) compile: 'setUp
	| animal perro moveteCode |
	animal := Object
		subclass: #Animal
		instanceVariableNames: ''''
		classVariableNames: ''''
		poolDictionaries: ''''
		category: self category.
		
	perro := animal subclass: #Perro
		instanceVariableNames: ''''
		classVariableNames: ''''
		poolDictionaries: ''''
		category: self category.
	
	moveteCode := ''movete
	Transcript show: ''''Camino en mis cuatro patas''''''.
	
	perro compile: moveteCode classified: ''Movilidad''.
	'.

(Smalltalk at: #SimpleExtractTraitTest) compile: 'testExtractTrait 
	SimpleExtractTraitRefactoring 
		extractTrait: #TCuadrupedo
		withMethods: #(movete)
		fromClass: (Smalltalk at: #Perro)
		
	'.

! !

!ScriptBuilder class methodsFor: 'as yet unclassified' stamp: 'npasserini 10/29/2011 20:08'!
PAOOMetaProgrammingScriptBuilder
"self PAOOMetaProgrammingScriptBuilder"

"Definition of package: PAOO-MetaProgramming-ScriptBuilder"
"Delete all current classes in package"
(PackageInfo named: 'PAOO-MetaProgramming-ScriptBuilder') classes do: [: class | class removeFromSystem ].

"Re-create package"
PackageInfo registerPackageName: 'PAOO-MetaProgramming-ScriptBuilder'.

"Definition of class: ScriptBuilder"
Object subclass: #ScriptBuilder
	instanceVariableNames: 'output'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PAOO-Metaprogramming-ScriptBuilder'.

(Smalltalk at: #ScriptBuilder) compile: 'output
	^ output' classified: #accessing.

(Smalltalk at: #ScriptBuilder) compile: 'addPackageNamed: packageName
	self addPackage: (self packageNamed: packageName) 
' classified: #adding.

(Smalltalk at: #ScriptBuilder) compile: 'addClassDefinition: aClass 
	self output
		nextPutAll: aClass definition;
		nextPut: $.;
		cr; cr.

	
	' classified: #adding.

(Smalltalk at: #ScriptBuilder) compile: 'basicNextPutClassName: class.
	self output
		nextPutAll: ''Smalltalk at: '';
		print: class name asSymbol.
' classified: #helpers.

(Smalltalk at: #ScriptBuilder) compile: 'nextPutClassName: class.
	self inParenthesis: [ self basicNextPutClassName: class ].
' classified: #helpers.

(Smalltalk at: #ScriptBuilder) compile: 'addMethod: method
	self nextPutClassName: method methodClass.
	self nextPutMethodBody: method.
' classified: #adding.

(Smalltalk at: #ScriptBuilder) compile: 'asMethod: aSelector in: aClass
	| methodSource |
	methodSource := WriteStream on: String new.
	methodSource 
		nextPutAll: aSelector; cr; 
		nextPutAll: ''"self ''; 
		nextPutAll: aSelector;
		nextPut: $";
		cr; cr.
	methodSource nextPutAll: self output contents.
	aClass compile: methodSource contents.
' classified: #main.

(Smalltalk at: #ScriptBuilder) compile: 'removePackage: aPackage.
	self addComment: ''Delete all current classes in package''.
	self inParenthesis: [
		self output 
			nextPutAll: ''PackageInfo named: '';
			print: aPackage packageName.
	].
	self output nextPutAll: '' classes do: [: class | class removeFromSystem ].''; cr; cr
' classified: #removing.

(Smalltalk at: #ScriptBuilder) compile: 'addClassMethod: method
	self nextPutClassName: method methodClass theNonMetaClass.
	self output nextPutAll: '' class ''.
	self nextPutMethodBody: method

' classified: #adding.

(Smalltalk at: #ScriptBuilder) compile: 'nextPutMethodBody: method
	self output 
		nextPutAll: '' compile: '';
		print: method getSource;
		nextPutAll: '' classified: '';
		print: method category;
		nextPut: $.; cr; cr.


' classified: #adding.

(Smalltalk at: #ScriptBuilder) compile: 'markPackageStart: aPackageName
	self addComment: ''Definition of package: '', aPackageName.
' classified: #comments.

(Smalltalk at: #ScriptBuilder) compile: 'packageNamed: packageName
	 ^ PackageInfo named: packageName.
' classified: #helpers.

(Smalltalk at: #ScriptBuilder) compile: 'initialize
	output := WriteStream on: String new.' classified: #'initialize-release'.

(Smalltalk at: #ScriptBuilder) compile: 'output: anObject
	output := anObject' classified: #accessing.

(Smalltalk at: #ScriptBuilder) compile: 'addComment: aString
	self output nextPut: $"; nextPutAll: aString; nextPut: $"; cr.

	
		.
	
	' classified: #comments.

(Smalltalk at: #ScriptBuilder) compile: 'rebuildPackageNamed: aPackageName
	| aPackage |
	self markPackageStart: aPackageName.
	aPackage := self packageNamed: aPackageName.
	
	self removePackage: aPackage.
	
	"Package creation script"
	self addPackageCreation: aPackage.
	
	aPackage classes do: [: class |
		self addClass: class.
	]
	
		.
	
	' classified: #main.

(Smalltalk at: #ScriptBuilder) compile: 'nextPutClassName: class ifPresent: aNiladicBlock
	self inParenthesis: [ 
		self basicNextPutClassName: class.
		self output nextPutAll: '' ifPresent: ''.
		self inSquareBrakets: [
			self output nextPutAll: '':class | class ''.
			aNiladicBlock value.
		].
	].' classified: #helpers.

(Smalltalk at: #ScriptBuilder) compile: 'addClass: aClass
	self addComment: ''Definition of class: '', aClass name.
	self addClassDefinition: aClass.
	
	aClass methodsDo: [: method |
		self addMethod: method.
	].
	
	aClass class methodsDo: [: method |
		self addClassMethod: method.
	]
	
		.
	
	' classified: #adding.

(Smalltalk at: #ScriptBuilder) compile: 'addPackageCreation: aPackage
	self addComment: ''Re-create package''.
	self output nextPutAll: ''PackageInfo registerPackageName: ''.
	aPackage packageName printOn: self output.
	self output nextPut: $.; cr; cr.' classified: #adding.

(Smalltalk at: #ScriptBuilder) compile: 'inSquareBrakets: aNiladicBlock.
	self output nextPut: $[.
	aNiladicBlock value.
	self output nextPut: $].' classified: #helpers.

(Smalltalk at: #ScriptBuilder) compile: 'inParenthesis: aNiladicBlock
	self output nextPut: $(.
	aNiladicBlock value.
	self output nextPut: $).
' classified: #helpers.

(Smalltalk at: #ScriptBuilder) compile: 'addPackage: aPackage
	self addComment: ''Definition of package: '', aPackage packageName.
	self addPackageCreation: aPackage.
	
	aPackage classes do: [: class |
		self addClass: class.
	]
	
		.
	
	' classified: #adding.

(Smalltalk at: #ScriptBuilder) compile: 'removeClass: class
	self nextPutClassName: class ifPresent: 
		[ self output nextPutAll: '' removeFromSystem.''].
	self output nextPut: $.; cr.
' classified: #removing.

(Smalltalk at: #ScriptBuilder) class  compile: 'PAOOMetaProgrammingTools
"self PAOOMetaProgrammingTools"

"Definition of package: PAOO-MetaProgramming-Tools"
"Delete all current classes in package"
(PackageInfo named: ''PAOO-MetaProgramming-Tools'') classes do: [: class | class removeFromSystem ].

"Re-create package"
PackageInfo registerPackageName: ''PAOO-MetaProgramming-Tools''.

"Definition of class: GenericComparator"
Object subclass: #GenericComparator
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''PAOO-MetaProgramming-Tools''.

(Smalltalk at: #GenericComparator) compile: ''unarySelectorsFor: aClass 
	^ aClass selectors select: #isUnary''.

(Smalltalk at: #GenericComparator) compile: ''compare: anObject with: anotherObject
"	^ anObject class instVarNames allSatisfy: [:variableName |
		(anObject instVarNamed: variableName) = (anotherObject instVarNamed: variableName)
	].
"	
	^ (self unarySelectorsFor: anObject class) allSatisfy: [:selector |
		(anObject perform: selector) = (anotherObject perform: selector)
	]
''.

' classified: #'as yet unclassified'.

(Smalltalk at: #ScriptBuilder) class  compile: 'forPackage: aPackageName
	ScriptBuilder new 
		rebuildPackageNamed: aPackageName;
		asMethod: aPackageName onlyLetters in: self class.' classified: #'as yet unclassified'.

(Smalltalk at: #ScriptBuilder) class  compile: 'PAOOMetaProgrammingRefactorings
"self PAOOMetaProgrammingRefactorings"

"Definition of package: PAOO-MetaProgramming-Refactorings"
"Delete all current classes in package"
(PackageInfo named: ''PAOO-MetaProgramming-Refactorings'') classes do: [: class | class removeFromSystem ].

"Re-create package"
PackageInfo registerPackageName: ''PAOO-MetaProgramming-Refactorings''.

"Definition of class: SimpleExtractSuperclassRefactoring"
Object subclass: #SimpleExtractSuperclassRefactoring
	instanceVariableNames: ''target superClassName selectors instanceVariableNames''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''PAOO-Metaprogramming-Refactorings''.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: ''createSuperclass.
	^ target superclass
		subclass:  self superClassName
		instanceVariableNames: self superclassInstanceVariablesDefinition
		classVariableNames:  ''''''''
		poolDictionaries:  ''''''''
		category: target category.
''.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: ''instanceVariableNames
	^ instanceVariableNames''.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: ''targetInstanceVariablesDefinition
	^ self instanceVariablesDefinitionFor: self targetInstanceVariables	
''.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: ''targetInstanceVariables	
	^ self target instVarNames difference: self instanceVariableNames 
''.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: ''instanceVariableNames: anObject
	instanceVariableNames := anObject''.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: ''moveMethodNamed: selector to: newClass
	| method |
	method := self target methodDictionary at: selector.
	self target removeSelector: selector.
	newClass compile: method getSource.
''.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: ''selectors: anObject
	selectors := anObject''.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: ''superClassName
	^ superClassName''.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: ''instanceVariablesDefinitionFor: aCollection
	^ (String streamContents: [:s | aCollection asStringOn: s delimiter: '''' '''' ])

''.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: ''execute
	| superclass |
	superclass := self createSuperclass.
	self selectors do: [:selector | self moveMethodNamed: selector to: superclass].
	self makeTargetSubclassOf: superclass.
''.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: ''selectors
	^ selectors''.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: ''superclassInstanceVariablesDefinition
	^ self instanceVariablesDefinitionFor: self instanceVariableNames.
''.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: ''makeTargetSubclassOf: superclass.
	superclass
		subclass:  self target name
		instanceVariableNames: self targetInstanceVariablesDefinition
		classVariableNames:  ''''''''
		poolDictionaries:  ''''''''
		category: target category.
''.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: ''target
	^ target''.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: ''superClassName: anObject
	superClassName := anObject''.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) compile: ''target: anObject
	target := anObject''.

(Smalltalk at: #SimpleExtractSuperclassRefactoring) class compile: ''extractSuperclass: newSuperClassName 
	withInstanceVariables: instanceVariableNames
	andMethods: selectors 
	fromClass: aClass 
	
	self new
		target: aClass;
		superClassName: newSuperClassName;
		instanceVariableNames: instanceVariableNames;
		selectors: selectors; 
		execute.
''.

"Definition of class: SimpleExtractTraitRefactoring"
Object subclass: #SimpleExtractTraitRefactoring
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''PAOO-Metaprogramming-Refactorings''.

(Smalltalk at: #SimpleExtractTraitRefactoring) class compile: ''extractTrait: traitName withMethods: selectors fromClass: aClass 
	| trait |
	trait := Trait named: traitName
		uses: {}
		category: aClass category.
		
	selectors do: [:selector | | method |
		method := aClass methodDictionary at: selector.
		aClass removeSelector: selector.
		trait compile: method getSource.
	].
	
	aClass addToComposition: trait.
''.

"Definition of class: SimpleExtractTraitTest"
TestCase subclass: #SimpleExtractTraitTest
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''PAOO-Metaprogramming-Refactorings''.

(Smalltalk at: #SimpleExtractTraitTest) compile: ''category
	^ self class category''.

(Smalltalk at: #SimpleExtractTraitTest) compile: ''tearDown
	(Smalltalk at: #Perro) removeFromSystem.
	(Smalltalk at: #Animal) removeFromSystem. 
	(Smalltalk at: #TCuadrupedo) removeFromSystem. 
''.

(Smalltalk at: #SimpleExtractTraitTest) compile: ''setUp
	| animal perro moveteCode |
	animal := Object
		subclass: #Animal
		instanceVariableNames: ''''''''
		classVariableNames: ''''''''
		poolDictionaries: ''''''''
		category: self category.
		
	perro := animal subclass: #Perro
		instanceVariableNames: ''''''''
		classVariableNames: ''''''''
		poolDictionaries: ''''''''
		category: self category.
	
	moveteCode := ''''movete
	Transcript show: ''''''''Camino en mis cuatro patas''''''''''''.
	
	perro compile: moveteCode classified: ''''Movilidad''''.
	''.

(Smalltalk at: #SimpleExtractTraitTest) compile: ''testExtractTrait 
	SimpleExtractTraitRefactoring 
		extractTrait: #TCuadrupedo
		withMethods: #(movete)
		fromClass: (Smalltalk at: #Perro)
		
	''.

' classified: #'as yet unclassified'.

(Smalltalk at: #ScriptBuilder) class  compile: 'PAOOMetaProgrammingExample
"self PAOOMetaProgrammingExample"

"Definition of package: PAOO-MetaProgramming-Example"
"Delete all current classes in package"
(PackageInfo named: ''PAOO-MetaProgramming-Example'') classes do: [: class | class removeFromSystem ].

"Re-create package"
PackageInfo registerPackageName: ''PAOO-MetaProgramming-Example''.

"Definition of class: AgeOfEmpiresTest"
TestCase subclass: #AgeOfEmpiresTest
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''PAOO-Metaprogramming-Example''.

(Smalltalk at: #AgeOfEmpiresTest) compile: ''testSaveGame
	| original saved fileName |
	
	"Crear un juego y bajarlo a disco"
	original := self crearMapaEjemplo.
	fileName := ''''game1.dat''''
	
	original saveAs: fileName.
	
	"Recuperar el juego del disco y ver que obtengo los mismos datos"
	saved := Mapa loadFrom: fileName.
	self assert: fileName = saved.
	'' classified: #tests.

"Definition of class: Mapa"
Object subclass: #Mapa
	instanceVariableNames: ''personajes''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''PAOO-Metaprogramming-Example''.

(Smalltalk at: #Mapa) compile: ''save: aFileName
	self flag: #todo'' classified: #''editing keys''.

(Smalltalk at: #Mapa) compile: ''personajes
	^ personajes'' classified: #accessing.

(Smalltalk at: #Mapa) compile: ''personajes: anObject
	personajes := anObject'' classified: #accessing.

(Smalltalk at: #Mapa) class  compile: ''loadFrom: aFileName
	self flag: #todo'' classified: #''as yet unclassified''.

"Definition of class: Soldado"
Object subclass: #Soldado
	instanceVariableNames: ''posicion puntosDeVida''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''PAOO-Metaprogramming-Example''.

(Smalltalk at: #Soldado) compile: ''posicion
	^ posicion.'' classified: #accessing.

(Smalltalk at: #Soldado) compile: ''golpear: aSoldado 
	aSoldado recibirDao: self fuerza.'' classified: #''as yet unclassified''.

(Smalltalk at: #Soldado) compile: ''initialize: aPoint 
	posicion := aPoint.
	puntosDeVida := 100.'' classified: #initialization.

(Smalltalk at: #Soldado) compile: ''atacar: unOponente
	(self estaCercaDe: unOponente) 
		whileFalse: [ self avanzarHacia: unOponente posicion ].
		
	self golpear: unOponente.'' classified: #''as yet unclassified''.

(Smalltalk at: #Soldado) compile: ''fuerza
	^ 10.'' classified: #''as yet unclassified''.

(Smalltalk at: #Soldado) compile: ''estaCercaDe: unOponente
	(self posicion dist: unOponente posicion) < 5'' classified: #''as yet unclassified''.

(Smalltalk at: #Soldado) compile: ''direccionHacia: unOponente
	(self posicion - unOponente posicion) normalized.'' classified: #''as yet unclassified''.

(Smalltalk at: #Soldado) compile: ''paso
	^ (puntosDeVida / 10)'' classified: #''as yet unclassified''.

(Smalltalk at: #Soldado) compile: ''avanzarHacia: unOponente
	posicion := posicion +  ((self direccionHacia: unOponente) * self paso)'' classified: #''as yet unclassified''.

(Smalltalk at: #Soldado) compile: ''recibirDao: unaPotencia
	puntosDeVida := puntosDeVida - unaPotencia'' classified: #''as yet unclassified''.

(Smalltalk at: #Soldado) class  compile: ''enPosicion: unaPosicion
	^ self new initialize: unaPosicion'' classified: #''as yet unclassified''.

' classified: #'as yet unclassified'.

! !

!ScriptBuilder class methodsFor: 'as yet unclassified' stamp: 'npasserini 10/28/2011 23:47'!
PAOOMetaProgrammingTools
"self PAOOMetaProgrammingTools"

"Definition of package: PAOO-MetaProgramming-Tools"
"Delete all current classes in package"
(PackageInfo named: 'PAOO-MetaProgramming-Tools') classes do: [: class | class removeFromSystem ].

"Re-create package"
PackageInfo registerPackageName: 'PAOO-MetaProgramming-Tools'.

"Definition of class: GenericComparator"
Object subclass: #GenericComparator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PAOO-MetaProgramming-Tools'.

(Smalltalk at: #GenericComparator) compile: 'unarySelectorsFor: aClass 
	^ aClass selectors select: #isUnary'.

(Smalltalk at: #GenericComparator) compile: 'compare: anObject with: anotherObject
"	^ anObject class instVarNames allSatisfy: [:variableName |
		(anObject instVarNamed: variableName) = (anotherObject instVarNamed: variableName)
	].
"	
	^ (self unarySelectorsFor: anObject class) allSatisfy: [:selector |
		(anObject perform: selector) = (anotherObject perform: selector)
	]
'.

! !

!ScriptBuilder class methodsFor: 'as yet unclassified' stamp: 'AdrielParedes 5/25/2012 20:22'!
UqbarMetaProgrammingExample
"self UqbarMetaProgrammingExample"

"Definition of package: Uqbar-MetaProgramming-Example"
"Delete all current classes in package"
(PackageInfo named: 'Uqbar-MetaProgramming-Example') classes do: [: class | class removeFromSystem ].

"Re-create package"
PackageInfo registerPackageName: 'Uqbar-MetaProgramming-Example'.

"Definition of class: AgeOfEmpiresTest"
TestCase subclass: #AgeOfEmpiresTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Uqbar-Metaprogramming-Example'.

(Smalltalk at: #AgeOfEmpiresTest) compile: 'testSaveGame
	| original saved fileName |
	
	"Crear un juego y bajarlo a disco"
	original := self crearMapaEjemplo.
	fileName := ''game1.dat''
	
	original saveAs: fileName.
	
	"Recuperar el juego del disco y ver que obtengo los mismos datos"
	saved := Mapa loadFrom: fileName.
	self assert: fileName = saved.
	' classified: #tests.

"Definition of class: Mapa"
Object subclass: #Mapa
	instanceVariableNames: 'personajes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Uqbar-Metaprogramming-Example'.

(Smalltalk at: #Mapa) compile: 'save: aFileName
	self flag: #todo' classified: #'editing keys'.

(Smalltalk at: #Mapa) compile: 'personajes
	^ personajes' classified: #accessing.

(Smalltalk at: #Mapa) compile: 'personajes: anObject
	personajes := anObject' classified: #accessing.

(Smalltalk at: #Mapa) class  compile: 'loadFrom: aFileName
	self flag: #todo' classified: #'as yet unclassified'.

"Definition of class: Soldado"
Object subclass: #Soldado
	instanceVariableNames: 'posicion puntosDeVida'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Uqbar-Metaprogramming-Example'.

(Smalltalk at: #Soldado) compile: 'atacar: unOponente
	(self estaCercaDe: unOponente) 
		whileFalse: [ self avanzarHacia: unOponente posicion ].
		
	self golpear: unOponente.' classified: #'as yet unclassified'.

(Smalltalk at: #Soldado) compile: 'posicion
	^ posicion.' classified: #accessing.

(Smalltalk at: #Soldado) compile: 'avanzarHacia: unOponente
	posicion := posicion +  ((self direccionHacia: unOponente) * self paso)' classified: #'as yet unclassified'.

(Smalltalk at: #Soldado) compile: 'initialize: aPoint 
	posicion := aPoint.
	puntosDeVida := 100.' classified: #initialization.

(Smalltalk at: #Soldado) compile: 'golpear: aSoldado 
	aSoldado recibirDao: self fuerza.' classified: #'as yet unclassified'.

(Smalltalk at: #Soldado) compile: 'direccionHacia: unOponente
	(self posicion - unOponente posicion) normalized.' classified: #'as yet unclassified'.

(Smalltalk at: #Soldado) compile: 'recibirDao: unaPotencia
	puntosDeVida := puntosDeVida - unaPotencia' classified: #'as yet unclassified'.

(Smalltalk at: #Soldado) compile: 'paso
	^ (puntosDeVida / 10)' classified: #'as yet unclassified'.

(Smalltalk at: #Soldado) compile: 'fuerza
	^ 10.' classified: #'as yet unclassified'.

(Smalltalk at: #Soldado) compile: 'estaCercaDe: unOponente
	(self posicion dist: unOponente posicion) < 5' classified: #'as yet unclassified'.

(Smalltalk at: #Soldado) class  compile: 'enPosicion: unaPosicion
	^ self new initialize: unaPosicion' classified: #'as yet unclassified'.

! !

!ScriptBuilder class methodsFor: 'as yet unclassified' stamp: 'npasserini 10/28/2011 23:47'!
forPackage: aPackageName
	ScriptBuilder new 
		rebuildPackageNamed: aPackageName;
		asMethod: aPackageName onlyLetters in: self class.! !

!ScriptBuilder methodsFor: 'adding' stamp: 'npasserini 10/28/2011 23:47'!
addClass: aClass
	self addComment: 'Definition of class: ', aClass name.
	self addClassDefinition: aClass.
	
	aClass methodsDo: [: method |
		self addMethod: method.
	].
	
	aClass class methodsDo: [: method |
		self addClassMethod: method.
	]
	
		.
	
	! !

!ScriptBuilder methodsFor: 'adding' stamp: 'npasserini 10/28/2011 23:47'!
addClassDefinition: aClass 
	self output
		nextPutAll: aClass definition;
		nextPut: $.;
		cr; cr.

	
	! !

!ScriptBuilder methodsFor: 'adding' stamp: 'npasserini 10/29/2011 19:58'!
addClassMethod: method
	self nextPutClassName: method methodClass theNonMetaClass.
	self output nextPutAll: ' class '.
	self nextPutMethodBody: method

! !

!ScriptBuilder methodsFor: 'comments' stamp: 'npasserini 10/28/2011 23:47'!
addComment: aString
	self output nextPut: $"; nextPutAll: aString; nextPut: $"; cr.

	
		.
	
	! !

!ScriptBuilder methodsFor: 'adding' stamp: 'npasserini 10/29/2011 19:59'!
addMethod: method
	self nextPutClassName: method methodClass.
	self nextPutMethodBody: method.
! !

!ScriptBuilder methodsFor: 'adding' stamp: 'npasserini 10/28/2011 23:47'!
addPackage: aPackage
	self addComment: 'Definition of package: ', aPackage packageName.
	self addPackageCreation: aPackage.
	
	aPackage classes do: [: class |
		self addClass: class.
	]
	
		.
	
	! !

!ScriptBuilder methodsFor: 'adding' stamp: 'npasserini 10/28/2011 23:47'!
addPackageCreation: aPackage
	self addComment: 'Re-create package'.
	self output nextPutAll: 'PackageInfo registerPackageName: '.
	aPackage packageName printOn: self output.
	self output nextPut: $.; cr; cr.! !

!ScriptBuilder methodsFor: 'adding' stamp: 'npasserini 10/28/2011 23:47'!
addPackageNamed: packageName
	self addPackage: (self packageNamed: packageName) 
! !

!ScriptBuilder methodsFor: 'main' stamp: 'npasserini 10/28/2011 23:47'!
asMethod: aSelector in: aClass
	| methodSource |
	methodSource := WriteStream on: String new.
	methodSource 
		nextPutAll: aSelector; cr; 
		nextPutAll: '"self '; 
		nextPutAll: aSelector;
		nextPut: $";
		cr; cr.
	methodSource nextPutAll: self output contents.
	aClass compile: methodSource contents.
! !

!ScriptBuilder methodsFor: 'helpers' stamp: 'npasserini 10/28/2011 23:47'!
basicNextPutClassName: class.
	self output
		nextPutAll: 'Smalltalk at: ';
		print: class name asSymbol.
! !

!ScriptBuilder methodsFor: 'helpers' stamp: 'npasserini 10/28/2011 23:47'!
inParenthesis: aNiladicBlock
	self output nextPut: $(.
	aNiladicBlock value.
	self output nextPut: $).
! !

!ScriptBuilder methodsFor: 'helpers' stamp: 'npasserini 10/28/2011 23:47'!
inSquareBrakets: aNiladicBlock.
	self output nextPut: $[.
	aNiladicBlock value.
	self output nextPut: $].! !

!ScriptBuilder methodsFor: 'initialize-release' stamp: 'npasserini 10/28/2011 23:47'!
initialize
	output := WriteStream on: String new.! !

!ScriptBuilder methodsFor: 'comments' stamp: 'npasserini 10/28/2011 23:47'!
markPackageStart: aPackageName
	self addComment: 'Definition of package: ', aPackageName.
! !

!ScriptBuilder methodsFor: 'helpers' stamp: 'npasserini 10/28/2011 23:47'!
nextPutClassName: class.
	self inParenthesis: [ self basicNextPutClassName: class ].
! !

!ScriptBuilder methodsFor: 'helpers' stamp: 'npasserini 10/28/2011 23:47'!
nextPutClassName: class ifPresent: aNiladicBlock
	self inParenthesis: [ 
		self basicNextPutClassName: class.
		self output nextPutAll: ' ifPresent: '.
		self inSquareBrakets: [
			self output nextPutAll: ':class | class '.
			aNiladicBlock value.
		].
	].! !

!ScriptBuilder methodsFor: 'adding' stamp: 'npasserini 10/29/2011 19:58'!
nextPutMethodBody: method
	self output 
		nextPutAll: ' compile: ';
		print: method getSource;
		nextPutAll: ' classified: ';
		print: method category;
		nextPut: $.; cr; cr.


! !

!ScriptBuilder methodsFor: 'accessing' stamp: 'npasserini 10/28/2011 23:47'!
output
	^ output! !

!ScriptBuilder methodsFor: 'accessing' stamp: 'npasserini 10/28/2011 23:47'!
output: anObject
	output := anObject! !

!ScriptBuilder methodsFor: 'helpers' stamp: 'npasserini 10/28/2011 23:47'!
packageNamed: packageName
	 ^ PackageInfo named: packageName.
! !

!ScriptBuilder methodsFor: 'main' stamp: 'npasserini 10/28/2011 23:47'!
rebuildPackageNamed: aPackageName
	| aPackage |
	self markPackageStart: aPackageName.
	aPackage := self packageNamed: aPackageName.
	
	self removePackage: aPackage.
	
	"Package creation script"
	self addPackageCreation: aPackage.
	
	aPackage classes do: [: class |
		self addClass: class.
	]
	
		.
	
	! !

!ScriptBuilder methodsFor: 'removing' stamp: 'npasserini 10/28/2011 23:47'!
removeClass: class
	self nextPutClassName: class ifPresent: 
		[ self output nextPutAll: ' removeFromSystem.'].
	self output nextPut: $.; cr.
! !

!ScriptBuilder methodsFor: 'removing' stamp: 'npasserini 10/28/2011 23:47'!
removePackage: aPackage.
	self addComment: 'Delete all current classes in package'.
	self inParenthesis: [
		self output 
			nextPutAll: 'PackageInfo named: ';
			print: aPackage packageName.
	].
	self output nextPutAll: ' classes do: [: class | class removeFromSystem ].'; cr; cr
! !
